> ## Documentation Index
> Fetch the complete documentation index at: https://docs.crossmint.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Link External Wallet to User

> Link an external wallet address to a user. Optionally provide a proof to verify ownership.

**API scope required**: `users.create`



## OpenAPI

````yaml put /2025-06-09/users/{userLocator}/linked-wallets/{address}
openapi: 3.0.0
info:
  title: Crossmint Users API
  description: Crossmint Users API
  version: 1.0.0
  contact:
    name: Crossmint Support
    url: https://www.crossmint.com
    email: support@crossmint.com
servers:
  - url: https://staging.crossmint.com/api
    description: Staging environment (testnets)
  - url: https://www.crossmint.com/api
    description: Production environment (mainnets)
security: []
tags: []
paths:
  /2025-06-09/users/{userLocator}/linked-wallets/{address}:
    put:
      tags:
        - Users - Linked Wallets
      summary: Link External Wallet to User
      description: >-
        Link an external wallet address to a user. Optionally provide a proof to
        verify ownership.


        **API scope required**: `users.create`
      operationId: LinkedWalletsController-linkWallet-2
      parameters:
        - name: X-API-KEY
          in: header
          description: API key required for authentication
          required: true
          schema:
            type: string
        - name: userLocator
          required: true
          in: path
          schema:
            type: string
        - name: address
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LinkWalletBodyDto'
      responses:
        '200':
          description: Wallet linked to user
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LinkedWalletResponseDto'
components:
  schemas:
    LinkWalletBodyDto:
      type: object
      properties:
        proof:
          type: string
          minLength: 1
          description: A signed message proving ownership of the wallet
        chain:
          type: string
          enum:
            - ethereum
            - polygon
            - arbitrum
            - base
            - solana
            - stellar
            - ethereum-sepolia
            - polygon-amoy
            - arbitrum-sepolia
            - base-sepolia
          description: The blockchain of the wallet
          example: solana
      required:
        - chain
      description: Request body for linking an external wallet to a user
    LinkedWalletResponseDto:
      type: object
      properties:
        address:
          type: string
          description: The wallet address
          example: '0x1234567890abcdef1234567890abcdef12345678'
        type:
          type: string
          enum:
            - external-wallet
          description: The type of linked wallet
          example: external-wallet
        ownership:
          discriminator:
            propertyName: verified
          oneOf:
            - type: object
              properties:
                verified:
                  type: boolean
                  enum:
                    - false
                  description: Whether the wallet ownership has been verified
                  example: false
                verificationChallenge:
                  type: string
                  description: >-
                    The challenge message that must be signed to verify
                    ownership
              required:
                - verified
                - verificationChallenge
              description: Ownership status for a wallet that has not yet been verified
            - type: object
              properties:
                verified:
                  type: boolean
                  enum:
                    - true
                  description: Whether the wallet ownership has been verified
                  example: true
              required:
                - verified
              description: Ownership status for a verified wallet
          description: Ownership verification status of the wallet
        chain:
          type: string
          enum:
            - ethereum
            - polygon
            - arbitrum
            - base
            - solana
            - stellar
            - ethereum-sepolia
            - polygon-amoy
            - arbitrum-sepolia
            - base-sepolia
          description: The blockchain of the wallet
          example: ethereum
      required:
        - address
        - chain
        - type
        - ownership
      description: Response for a linked external wallet

````